SystemOrganization addCategory: #'System-Launcher'!

Object subclass: #AbstractLauncher
	instanceVariableNames: 'parameters'
	classVariableNames: 'ReadDocumentAtStartup'
	poolDictionaries: ''
	category: 'System-Launcher'!

!AbstractLauncher commentStamp: '<historical>' prior: 0!
The class AutoStart in combination with the Launcher classes provides a mechanism for starting Squeak from the command line or a web page. Parameters on the command line or in the embed tag in the web page a parsed and stored in the lauchner's parameter dictionary.
Subclasses can access these parameters to determine what to do.

CommandLineLauncherExample provides an example for a command line application. if you start squeak with a command line 'class Integer' it will launch a class browser on class Integer.
To enable this execute
CommandLineLauncherExample activate
before you save the image.
To disable execute
CommandLineLauncherExample deactivate

The PluginLauncher is an example how to use this framework to start Squeak as a browser plugin. It looks for a parameter 'src' which should point to a file containing a squeak script.!

!AbstractLauncher class methodsFor: 'activation' stamp: 'mir 8/6/1999 18:14'!
activate
	"Register this launcher with the auto start class"

	self autoStarter addLauncher: self! !

!AbstractLauncher class methodsFor: 'private' stamp: 'MarcusDenker 4/18/2011 11:02'!
autoStarter
	^nil! !

!AbstractLauncher class methodsFor: 'activation' stamp: 'MarcusDenker 8/18/2010 11:18'!
deactivate
	"Unregister this launcher with the auto start class"
	self autoStarter removeLauncher: self! !

!AbstractLauncher class methodsFor: 'settings' stamp: 'pavel.krivanek 10/16/2010 22:31'!
readDocumentAtStartup
	^ ReadDocumentAtStartup ifNil: [ReadDocumentAtStartup := true]! !

!AbstractLauncher class methodsFor: 'settings' stamp: 'pavel.krivanek 10/16/2010 22:32'!
readDocumentAtStartup: aBoolean
	ReadDocumentAtStartup := aBoolean! !

!AbstractLauncher methodsFor: 'private' stamp: 'MarcusDenker 8/18/2010 11:17'!
commandLine: aString
	"Start up this launcher from within Squeak as if it Squeak been launched the given command line."

	| dict tokens cmd arg |
	dict := Dictionary new.
	tokens := (aString findTokens: ' ') readStream.
	[ 
	cmd := tokens next.
	arg := tokens next.
	cmd notNil and: [ arg notNil ] ] whileTrue: [ dict at: cmd put: arg ].
	self parameters: dict.
	self startUp! !

!AbstractLauncher methodsFor: 'private' stamp: 'mir 8/4/1999 14:19'!
parameterAt: parName
	"Return the parameter named parName or an empty string"
	^self
		parameterAt: parName
		ifAbsent: ['']! !

!AbstractLauncher methodsFor: 'private' stamp: 'mir 1/11/2000 16:36'!
parameterAt: parName ifAbsent: aBlock
	"Return the parameter named parName.
	Evaluate the block if parameter does not exist."
	^self parameters
		at: parName asUppercase
		ifAbsent: [aBlock value]! !

!AbstractLauncher methodsFor: 'private' stamp: 'StephaneDucasse 3/17/2010 20:51'!
parameters
	parameters ifNil: [parameters := Smalltalk extractParameters].
	^parameters! !

!AbstractLauncher methodsFor: 'private' stamp: 'mir 7/29/1999 10:21'!
parameters: startupParameters
	parameters := startupParameters! !

!AbstractLauncher methodsFor: 'settings' stamp: 'pavel.krivanek 10/16/2010 22:32'!
readDocumentAtStartup
	^ self class readDocumentAtStartup! !

!AbstractLauncher methodsFor: 'running' stamp: 'tk 10/24/2001 06:40'!
startUp
	"A backstop for subclasses.  Note that this is not a class message (most startUps are class messages)."

! !
